// This is the main DLL file.

#include "stdafx.h"

#include "FastSerialPort.h"

bool FastSerialPort::FastSerialPort::SendMessage(array<BYTE>^ data, int length)
{
	OVERLAPPED osWrite = {0};
	DWORD bytesSent;

	BYTE tdata[50];

	for (int iii=0; iii<length; iii++)
		tdata[iii] = data[iii];

	osWrite.hEvent = CreateEvent(NULL, TRUE, FALSE, NULL);

	if (WriteFile(m_hSerialPort, tdata, length, &bytesSent, &osWrite) == 0)
	{
		if (GetLastError() == ERROR_IO_PENDING)
			GetOverlappedResult(m_hSerialPort, &osWrite, &bytesSent, TRUE);
		else
			return false;
	}

	if (bytesSent != length)
	{
		return false;
	}

	CloseHandle(osWrite.hEvent);
	return true;
}

bool FastSerialPort::FastSerialPort::OpenPort(array<TCHAR>^ port, int length)
{
	TCHAR tport[15];

	for (int iii=0; iii<length; iii++)
		tport[iii] = port[iii];
	tport[length] = 0;

	m_hSerialPort = CreateFile(tport, 
            GENERIC_READ | GENERIC_WRITE, 
            0, 
            NULL, 
            OPEN_EXISTING, 
            FILE_FLAG_OVERLAPPED, 
            NULL);

	if (m_hSerialPort == INVALID_HANDLE_VALUE)
	{
		return false;
	}

	DCB dcbConfig;

	if(GetCommState(m_hSerialPort, &dcbConfig))
	{
		dcbConfig.BaudRate = 9600;
		dcbConfig.ByteSize = 8;
		dcbConfig.Parity = NOPARITY;
		dcbConfig.StopBits = ONESTOPBIT;
		dcbConfig.fDsrSensitivity = FALSE;
		dcbConfig.fDtrControl = DTR_CONTROL_ENABLE;
		dcbConfig.fBinary = TRUE;
		dcbConfig.fRtsControl = RTS_CONTROL_ENABLE;
		dcbConfig.fOutxCtsFlow = TRUE;
	}
	else
	{
		return false;
	}


	if(!SetCommState(m_hSerialPort, &dcbConfig))
	{
		return false;
	}

	COMMTIMEOUTS commTimeout;

	if(GetCommTimeouts(m_hSerialPort, &commTimeout)) /* Configuring Read & Write Time Outs */
  	{
  		commTimeout.ReadIntervalTimeout = 1000;
  		commTimeout.ReadTotalTimeoutConstant = 1000;
  		commTimeout.ReadTotalTimeoutMultiplier = 0;
  		commTimeout.WriteTotalTimeoutConstant = 10000;
  		commTimeout.WriteTotalTimeoutMultiplier = 0;
  	} 
  	else
	{
		return false;
	}
  
  	if(!SetCommTimeouts(m_hSerialPort, &commTimeout))
	{
		return false;
	}

	return true;
}

void FastSerialPort::FastSerialPort::ReceiveMessages()
{	
	m_bConnected = false;

	int receivedIndex = 0;
	array<BYTE>^ receivedMessage = gcnew array<BYTE>(18);

	OVERLAPPED osRead = {0};
	osRead.hEvent = CreateEvent(NULL,TRUE, FALSE, NULL);

  	while(true)
	{
		BYTE buffer;
		DWORD readSize;

		if (ReadFile(m_hSerialPort, &buffer, 1, &readSize, &osRead) == 0)
		{
			if (GetLastError()== ERROR_IO_PENDING)
				GetOverlappedResult(m_hSerialPort, &osRead, &readSize, TRUE);
			else
				break;
		}

		if (readSize != 0)
		{
			if (receivedIndex == 0)
			{
				if (buffer == 0x01 || buffer == 0x03)
				{
					m_bConnected = true;
					receivedMessage[0] = buffer;
					ReceivedMessage(receivedMessage, 1);
				}

				if (!m_bConnected)
					continue;

				if (buffer == 0x05)
				{
					m_bConnected = true;
					receivedMessage[0] = buffer;
					receivedIndex++;
				}
			}
			else
			{
				m_bConnected = true;
				receivedMessage[receivedIndex] = buffer;
				receivedIndex++;

				if (receivedIndex == 18)
				{
					receivedIndex=0;
					ReceivedMessage(receivedMessage, 18);
				}
			}
		}
	}
}

void FastSerialPort::FastSerialPort::Close()
{
	CloseHandle(m_hSerialPort);
}


