using System;
using System.Collections.Generic;
using System.Text;
using System.Threading;
using FastSerialPort;

namespace LocalTimeReader
{
    public class ConnectedSerialPort: FastSerialPort.FastSerialPort
    {
        private bool portOpen;
        private Thread receivingThread = null;

        public ConnectedSerialPort()
        {
            portOpen = false;
        }

        public bool OpenPort(string port)
        {
            if (portOpen)
                return true;

            portOpen = OpenPort(port.ToCharArray(), port.Length);

            if (portOpen)
                StartReceiving();

            return portOpen;
        }

        private void StartReceiving()
        {
            receivingThread = new Thread(this.ReceiveMessages);
            receivingThread.Start();
        }

        public virtual void ClosePort()
        {
            if (receivingThread != null)
                receivingThread.Abort();
            receivingThread = null;
            portOpen = false;
            Close();
        }
    }
}
