using System;
using System.Collections.Generic;
using System.Text;

namespace LocalTimeReader
{
    public class Message
    {
        public enum MessageStatus
        {
            Complete,
            ResendError,
            IgnoreError
        }

        private byte code;
        private MessageStatus status;
        private long localTime;
        private long remoteTime;
        private byte index;

        public Message(byte[] data, int length)
        {
            if (length < 1)
                status = MessageStatus.IgnoreError;

            code = data[0];

            if (code != 0x01 && code != 0x03 && code != 0x05)
            {
                status = MessageStatus.ResendError;
                return;
            }

            status = MessageStatus.Complete;

            if (code == 0x05)
            {
                index = data[1];

                localTime = (long)BitConverter.ToInt64(data, 2);
                remoteTime = (long)BitConverter.ToInt64(data, 10);
            }
        }

        public byte Code
        {
            get { return code; }
        }

        public MessageStatus Status
        {
            get { return status; }
        }

        public long LocalTime
        {
            get { return localTime; }
        }

        public long RemoteTime
        {
            get { return remoteTime; }
        }

        public byte Index
        {
            get { return index; }
        }
    }
}
